﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.geom.ColorTransform;
	/*
	*	Le principe des courbes de lissajou est basé sur la composition de 2 mouvements sinusoidales
	*	Un mouvement d'aller-retour horizontal
	*	Un mouvement d'aller-retour vertical
	*	La difference entre les vitesses d'implémentation de l'angle vont créer des courbes très différentes
	*	La difference des rayons d'angle également.
	*/
	[SWF(width="600", height="600", backgroundColor="#ffffff", frameRate="120")]
	public class Lissajou extends Sprite
	{
		private var background:Bitmap;
		private var data:BitmapData;
		private var horizontal_support:Sprite;
		private var horizontal_angle:Number = 0;
		private var vertical_support:Sprite;
		private var vertical_angle:Number = 0;
		private var canevas:Sprite;
		private var vitesseH:Number;
		private var vitesseV:Number;
		private var newcolor:Number;
		private var Ftimer: Timer;
		private var Ftimer1: Timer;
		private var red : Number=50;
		private var blue : Number=200;
		private var green : Number=200;
		//private var XFtimer:Number;

		
		
		
	
		
		public function Lissajou()
		{
			data = new BitmapData(600,600,false,0xFFFFFF);
			background = new Bitmap(data);
			
			addChild(background);
			canevas = new Sprite();	
			addChild(canevas);
			
			/*
			 * PARAMETRAGE DES VITESSES 
			 * EN MODIFIANT CES PARAMETRES VOUS AUREZ DES COURBES VARIANTES
			 */
			vitesseH = 2.5;
			vitesseV = 1;
			
			
			buildHorizontalMovement();
		}
		
		private function buildHorizontalMovement():void
		{
			horizontal_support = new Sprite();
			horizontal_support.x= 100;
			horizontal_support.y= 200;
		
			canevas.addChild(horizontal_support)
			horizontal_support.addEventListener(Event.ENTER_FRAME,horizontal_enter_handler);
			
			buildVerticalMovement(horizontal_support);
		}
		
		private function horizontal_enter_handler(e:Event):void
		{
			horizontal_angle+=vitesseH;
			e.currentTarget.x = Math.sin(horizontal_angle*Math.PI/180)*400 + 290;
			e.currentTarget.transform.colorTransform = new ColorTransform(red,green,blue,1,0,1,0,0)
		}
		
		
		
		

		
		
		
		private function buildVerticalMovement(clip:Sprite):void
		{
			vertical_support = new Sprite();
			newcolor = Math.random()*0xffffff;
			Ftimer= new Timer(1000,0);
			Ftimer1= new Timer(2000,0);
			vertical_support.graphics.beginFill(newcolor,0.01);
			vertical_support.graphics.moveTo(horizontal_support.x,horizontal_support.y);
			vertical_support.graphics.lineTo(500,50);
			vertical_support.graphics.lineTo(10,500);
			vertical_support.graphics.endFill();
			//trace(vertical_support)
			
			  
			clip.addChild(vertical_support);
	
		    Ftimer.addEventListener(TimerEvent.TIMER,TournerV);
		    Ftimer.start(); 
			
			
			Ftimer1.addEventListener(TimerEvent.TIMER,Colorié);
		    Ftimer1.start(); 
			
			//trace(Ftimer);
			
			vertical_support.addEventListener(Event.ENTER_FRAME,vertical_enter_handler);
		}
		
		private function TournerV (evt: TimerEvent):void 
		    {
				//trace("ROTATION");
		        vertical_support.rotation+=30;		
		    }
			
			
			
			private function Colorié (evt: TimerEvent):void 
		    {
				//trace("CHNAGEMEMT DE COULEUR");
				blue 	=  Math.round(Math.random()*100+100);
				green 	=  Math.round(Math.random()*100+100);
				red 	=  Math.round(Math.random()*100+100);
				 
		    }
		
		
		private function vertical_enter_handler(e: Event):void
		{
			vertical_angle+=vitesseV;
			e.currentTarget.y = Math.sin(vertical_angle*Math.PI/80)*400;
			data.draw(canevas);
		}
	}
}